# coding: utf-8

#
module Gomasio
  #
  class Disk
    include(Comparable)
    #
    DISC_RAW_ID = { empty: 0, black: -1, white: 1 }
    #
    attr_reader :raw

    #
    def initialize(color)
      @raw = DISC_RAW_ID[color]
    end

    #
    def <=>(other)
      raw <=> other.raw
    end

    #
    def to_s
      DISC_RAW_ID.invert[@raw].to_s
    end

    #
    def reverse
      self.class.send(DISC_RAW_ID.invert[-@raw])
    end

    %i(white empty black).each do |color|
      instance_variable_set("@#{color}", Disk.new(color))
      class_eval <<-EOL
        def #{color}?
          self == self.class.#{color}
        end

        def self.#{color}
          instance_variable_get("@#{color}")
        end
      EOL
    end
  end
end
